#ifndef SRCOMM3_Ansi_h
#define SRCOMM3_Ansi_h

class AnsiOutput
{
  private:
    string str;       // stores ANSI escape sequence
    int savex, savey;     // saved cursor position

    virtual void gotoxy( int x, int y ) = 0;
    virtual void clreol() = 0;
    virtual void clrscr( int y1 = -1, int y2 = -1 ) = 0;
    virtual void setattr( int a ) = 0;
    virtual int whereX() = 0;
    virtual int whereY() = 0;
    virtual void beep() = 0;
    virtual void putchar( char c ) = 0;
    virtual int width() = 0;
    virtual int height() = 0;
    virtual int currentcolor() = 0;

    void tabulate();
    void backspace();
    void write( const string& s );
    int  write( char c );
    void parseparam( int& n, int values[], int len );

  public:
    AnsiOutput();
    virtual ~AnsiOutput();

	int put( char ch );
};

#endif
