#ifndef SRCOMM3_Time_h
#define SRCOMM3_Time_h

// Date and Time class.  This stores both the date and time in the unix
// standard time format -- the number of seconds since some time in the
// 70's.  It's easier to work with this than with hour, minute, second,
// because you can perform math easily on this form.
struct Time
{
    static char TimeSeparatorChar;
    static int Hour24;
    static Time MIN;
    static Time MAX;

    long unixdate;

	Time();
	Time( long x ) { unixdate = x; }
	Time( int year, int mon, int day );

	long Second() const;
	long Minute() const;
	long Hour() const;
	long Day() const;
	long Month() const;
	long Year() const;
	long Clock() const { return unixdate; }
};

class standardout;
class standardin;
long operator - ( Time a, Time b );
Time operator + ( Time a, long b );
inline Time& operator += ( Time& t, long b ) { t = t + b; return t; }
inline Time& operator -= ( Time& t, long b ) { t = t - b; return t; }
inline int operator == ( Time a, Time b ) { return a.unixdate == b.unixdate; }
inline int operator != ( Time a, Time b ) { return a.unixdate != b.unixdate; }
inline int operator < ( Time a, Time b ) { return a.unixdate < b.unixdate; }
inline int operator > ( Time a, Time b ) { return a.unixdate > b.unixdate; }
inline int operator <= ( Time a, Time b ) { return a.unixdate <= b.unixdate; }
inline int operator >= ( Time a, Time b ) { return a.unixdate >= b.unixdate; }
Time DateOnly( Time x );
standardout& operator << ( standardout& out, Time x );
standardin& operator >> ( standardin& in, Time& x );
const char * DateDisplay( Time t );

extern Time Today;

#endif
