#ifndef SRCOMM3_Door_h
#define SRCOMM3_Door_h

// DoorInfo grabs data from DOORFILE.SR and lets the program access it

#include <srcomm3/types.h>

class DoorInfo
{
  private:
	static const char *DoorFile;

    string name;
    string realname;
	int ansi;
	int ibmcharacters;
	int pagelength;
	int comport;
	unsigned baudrate, realbaudrate;
	int timelimit;

	int loaded;

  public:
	DoorInfo();
	~DoorInfo();

	operator const string& () const { return name; }
    int Ansi()            { return ansi; }
    int IBMCharacters()       { return ibmcharacters; }
    int PageLength()        { return pagelength; }
	int ComPort()			{ return comport; }
	unsigned BaudRate() 		{ return baudrate; }
	unsigned RealBaudRate() 	{ return realbaudrate; }
	int TimeLimit()			{ return timelimit; }
    void AddTime( int x )       { (timelimit<0)? 0 : ( timelimit += x, ( timelimit > 999 )? timelimit = 999: 0 ); }
    void SubTime( int x )       { (timelimit<0)? 0 : ( timelimit -= x, ( timelimit < 0 )? timelimit = 0: 0 ); }
	bool exists()           { return loaded; }
	int read();
    void init();

	int TimeOut();			// is the time limit expired?
};

extern DoorInfo DOOR;

int displayfile( string filename );

#endif  DOOR_H
