#include <DynArray.h>

extern void myabort();

DynArrayBase::DynArrayBase( int initsize )
{
    size = initsize;
    if( size < 8 ) size = 8;
    num = 0;
    data = new void* [ size ];
};

DynArrayBase::~DynArrayBase()
{
	delete [] data;
}

void DynArrayBase::clear()
{
    for( int i = 0; i < num; i++ )
        destruct( i );
    for( i = 0; i < size; i++ )
		data[i] = 0;
	num = 0;
}

void DynArrayBase::resize( int newsize )
{
    if( newsize > size )
    {
        size = 2*size;
        void** newdata = new void* [ size ];
        for( int i = 0; i < num; i++ )
            newdata[i] = data[i];
        for( ; i < size; i++ )
            newdata[i] = 0;
        delete [] data;
        data = newdata;
    }
}

int DynArrayBase::insert( void* x, int where )
{
	if( where > num ) where = num;
	if( where < 0 ) where = 0;
	resize( num+1 );
	for( int i = num; i > where; i-- )
		data[i] = data[i-1];
	data[where] = x;
	num++;
    return where;
}

int DynArrayBase::push( void* x )
{
    return insert( x, 0 );
}

int DynArrayBase::append( void* x )
{
    return insert( x, num );
}

void DynArrayBase::remove( int where )
{
    if( where < 0 || where >= num ) return;
    destruct( where );
    for( int i = where+1; i < num; i++ )
        data[i-1] = data[i];
    data[num--] = 0;
}

void* DynArrayBase::element( int i ) const
{
    if( i >= 0 && i < num )
    {
        if( !data[i] ) myabort();
        return data[i];
    }
	myabort();
	return data[0];
}

