#ifndef DynArray_h
#define DynArray_h

// DynArray is a growing/shrinking array
class DynArrayBase
{
  protected:
	void** data;
	int size;
	int num;

    int insert( void* x, int where = 0 );
    int append( void* x );
    int push( void* x );
	void resize( int newsize );
	void* element( int i ) const;

  public:
	DynArrayBase( int initsize = 8 );
    virtual ~DynArrayBase();

    void clear();
	void remove( int where );

	int length() const { return num; }
    virtual void destruct( int i ) = 0;
};

template<class T>
class DynArray: public DynArrayBase
{
  private:
    DynArray( const DynArray<T> & ) {}
	void operator = ( const DynArray<T> & ) {}

  public:
	DynArray( int initsize = 8 ): DynArrayBase(initsize) {}
	~DynArray() { clear(); }
	T& operator [] ( int i ) { return *((T*)element(i)); }
	T operator [] ( int i ) const { return *((T*)element(i)); }
    int append() { return DynArrayBase::append( (void *)( new T ) ); }
    int push() { return DynArrayBase::push( (void *)( new T ) ); }
    int append( const T& x ) { return DynArrayBase::append( (void *)( new T(x) ) ); }
    int push( const T& x ) { return DynArrayBase::push( (void *)( new T(x) ) ); }
    virtual void destruct( int i );
};

template<class T> void DynArray<T>::destruct( int i )
{ delete (T*)(data[i]); }

#endif

