//////////////////////////////////////////////////////////////////////
// NEWS                                                             //
//////////////////////////////////////////////////////////////////////
// This unit gives you news files (today & yesterday), the          //
// FilterInput function (it just lets the user press one of a set   //
// of keys), and an error log which interfaces to the status bar    //
// to display the most recent error in a status window.  Just a     //
// whole bunch of unrelated functions and classes...                //
//////////////////////////////////////////////////////////////////////

#include <dos.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>

#include <srcomm3/srinout.h>
#include <srcomm3/finout.h>

#include <srcomm3/News.h>
#include <srcomm3/srparam.h>

attr aBold(14);
attr aBracket(12);
attr aNumber(14);

Resource ANSINewsFileName( "News.Ansi.Today", "NEWS.ANS" );
Resource TextNewsFileName( "News.Text.Today", "NEWS.TXT" );
Resource ANSINewsFileName1( "News.Ansi.Yesterday", "NEWS1.ANS" );
Resource TextNewsFileName1( "News.Text.Yesterday", "NEWS1.TXT" );
Resource ANSINewsFileName2( "News.Ansi.Yesterday", "NEWS2.ANS" );
Resource TextNewsFileName2( "News.Text.Yesterday", "NEWS2.TXT" );
Resource ANSINewsFileName3( "News.Ansi.Yesterday", "NEWS3.ANS" );
Resource TextNewsFileName3( "News.Text.Yesterday", "NEWS3.TXT" );
Resource ANSINewsFileName4( "News.Ansi.Yesterday", "NEWS4.ANS" );
Resource TextNewsFileName4( "News.Text.Yesterday", "NEWS4.TXT" );
Resource ANSINewsFileName5( "News.Ansi.Yesterday", "NEWS5.ANS" );
Resource TextNewsFileName5( "News.Text.Yesterday", "NEWS5.TXT" );
Resource ANSINewsFileName6( "News.Ansi.Yesterday", "NEWS6.ANS" );
Resource TextNewsFileName6( "News.Text.Yesterday", "NEWS6.TXT" );
Resource ANSINewsFileName7( "News.Ansi.Yesterday", "NEWS7.ANS" );
Resource TextNewsFileName7( "News.Text.Yesterday", "NEWS7.TXT" );
Resource ANSINewsFileName8( "News.Ansi.Yesterday", "NEWS8.ANS" );
Resource TextNewsFileName8( "News.Text.Yesterday", "NEWS8.TXT" );
Resource ANSINewsFileName9( "News.Ansi.Yesterday", "NEWS9.ANS" );
Resource TextNewsFileName9( "News.Text.Yesterday", "NEWS9.TXT" );

static fileout ANSINews;
static fileout TextNews;
NewsFile News;

static void NewsTranslator( standardout& out )
{
    ANSINews << attr( out.GetForeground(), out.GetBackground() );
}

void NewsFile::open()
{
	ANSINews.open( ANSINewsFileName, 1 );
	TextNews.open( TextNewsFileName, 1 );
    setColorTranslator( NewsTranslator );
}

void NewsFile::close()
{
	ANSINews.close();
	TextNews.close();
}

void CC NewsFile::_put( int len, const char c[] )
{
    ANSINews.put( len, c );
    TextNews.put( len, c );
}

int FilterInput( const char* set, int upper )
{
	char def = 0;
	if( set[0] == '\0' )
		set++;
	else
		def = set[0];
	for(;;)
	{
		char ch;
		kin >> ch;
		if( ch == '\r' ) ch = def;
        if( upper ) ch = toupper( ch );
        if( ch && strchr( set, ch ) != 0 )
			return ch;
	}
}

errorfileout ErrorLog;

errorfileout::errorfileout(): standardout(255), msg(255)
{
    current_fore = 14;
    new_fore = 14;
}

errorfileout::~errorfileout()
{
}

void CC errorfileout::_put( int len, const char c[] )
{
    for( int i = 0; i < len; i++ )
    {
        if( c[i] == '\n' )
        {
            msg = Buffer();
            fileout f( "SYSOP.LOG", 1 );
            f << msg << '\n';

            void DisplayMessagesHook();
            DisplayMessagesHook();
        }
    }
}

