#ifndef SRCOMM3_SrParam_h
#define SRCOMM3_SrParam_h

// SRPARAM is used for grabbing resource.dat or commandline options

#include <CString.h>
#include <unit/DynArray.h>

struct Atom
{
	string s;
	long n;

	enum AtomType
	{
        tNone, tString, tNumber
	} type;

	Atom();
};

class Resource
{
    string name;
    DynArray<Atom> value;
	int initialized;

    void CC set( string newvalue );
	void CC set( const Atom& x );
	void CC set( const DynArray<Atom>& x );
    void CC read();

    static void Read( string name );
	static void Read();

  public:
    Resource( const char *s, const char * default_value );
    Resource( const char *s, string default_value );
    Resource( const char *s, long default_value );
    ~Resource();

	CC operator string();
	CC string operator[] ( int index );
	CC int length();

	long CC Long( int i = 0 );
	int CC Int( int i = 0 );
	int CC Boolean( int i = 0 );
};

int CC Parameter( string s );
int CC Parameter( const char* s );

#endif

